/// <reference types="react" />
import * as React from 'react';
import { TButtonProps } from '../Button/Button';
import { ComponentClass, ComponentType } from 'react';
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/lib/object/object';
import { TBaseIconProps } from '@devexperts/icons/lib/icon.component';
export declare const BUTTON_ICON: symbol;
export declare type TFullButtonIconProps = ObjectClean<TButtonProps & {
    Button: ComponentType<TButtonProps>;
    icon: React.ReactElement<TBaseIconProps>;
    theme: {
        icon?: string;
    } & TButtonProps['theme'];
}>;
export declare type TButtonIconProps = ObjectClean<PartialKeys<TFullButtonIconProps, 'Button' | 'theme'>>;
export declare const ButtonIcon: ComponentClass<TButtonIconProps>;
