'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.MenuItemGroup = exports.MenuItem = exports.Menu = exports.MENU = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _List = require('../List/List');

var _withTheme = require('../../utils/withTheme');

var _pure = require('../../utils/pure');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Pure = require('../Pure/Pure');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MENU = exports.MENU = Symbol('Menu');

var RawMenu = function (_React$Component) {
    _inherits(RawMenu, _React$Component);

    function RawMenu() {
        _classCallCheck(this, RawMenu);

        return _possibleConstructorReturn(this, (RawMenu.__proto__ || Object.getPrototypeOf(RawMenu)).apply(this, arguments));
    }

    _createClass(RawMenu, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                children = _props.children,
                List = _props.List;

            return React.createElement(List, Object.assign({}, this.props), React.Children.map(children, function (child) {
                var props = {
                    onSelect: _this2.props.onItemSelect
                };
                return React.cloneElement(child, props);
            }));
        }
    }]);

    return RawMenu;
}(React.Component);

RawMenu.defaultProps = {
    List: _List.List
};
var Menu = exports.Menu = (0, _withTheme.withTheme)(MENU)(RawMenu);
var RawMenuItem = function (_Component) {
    _inherits(RawMenuItem, _Component);

    function RawMenuItem() {
        _classCallCheck(this, RawMenuItem);

        var _this3 = _possibleConstructorReturn(this, (RawMenuItem.__proto__ || Object.getPrototypeOf(RawMenuItem)).apply(this, arguments));

        _this3.onClick = function () {
            _this3.props.onSelect && _this3.props.onSelect(_this3.props.value);
        };
        return _this3;
    }

    _createClass(RawMenuItem, [{
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                isActive = _props2.isActive,
                ListItem = _props2.ListItem;
            var theme = this.props.theme;

            if (isActive) {
                theme = Object.assign({}, theme, { item: (0, _classnames2.default)(theme.item, theme.item_active) });
            }
            return React.createElement(ListItem, Object.assign({ onClick: this.onClick }, this.props, { theme: theme }), React.createElement("div", { className: theme.item__content }, this.props.children));
        }
    }]);

    return RawMenuItem;
}(_react.Component);
RawMenuItem.defaultProps = {
    ListItem: _List.ListItem
};
RawMenuItem = tslib_1.__decorate([_pure.PURE], RawMenuItem);
var MenuItem = exports.MenuItem = (0, _withTheme.withTheme)(MENU)(RawMenuItem);
var RawMenuItemGroup = function (_React$Component2) {
    _inherits(RawMenuItemGroup, _React$Component2);

    function RawMenuItemGroup() {
        _classCallCheck(this, RawMenuItemGroup);

        var _this4 = _possibleConstructorReturn(this, (RawMenuItemGroup.__proto__ || Object.getPrototypeOf(RawMenuItemGroup)).apply(this, arguments));

        _this4.state = {
            isCollapsed: true
        };
        _this4.onClick = function () {
            _this4.setState({
                isCollapsed: !_this4.state.isCollapsed
            });
        };
        return _this4;
    }

    _createClass(RawMenuItemGroup, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.setState({
                isCollapsed: this.props.isCollapsed
            });
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            this.setState({
                isCollapsed: props.isCollapsed
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this5 = this;

            var _props3 = this.props,
                children = _props3.children,
                theme = _props3.theme,
                ListItemGroup = _props3.ListItemGroup;

            var header = void 0;
            if (this.props.header) {
                header = React.createElement("div", { className: theme.itemGroup__header__content }, this.props.header);
            }
            return React.createElement(ListItemGroup, Object.assign({ onClick: this.onClick }, this.props, { header: header, isCollapsed: this.state.isCollapsed }), React.createElement(_Pure.Pure, { check: children }, function () {
                return React.cloneElement(React.Children.only(children), {
                    onItemSelect: _this5.props.onSelect
                });
            }));
        }
    }]);

    return RawMenuItemGroup;
}(React.Component);
RawMenuItemGroup.defaultProps = {
    ListItemGroup: _List.ListItemGroup,
    List: Menu,
    isCollapsed: true //menu is always collapsed
};
RawMenuItemGroup = tslib_1.__decorate([_pure.PURE], RawMenuItemGroup);
var MenuItemGroup = exports.MenuItemGroup = (0, _withTheme.withTheme)(MENU)(RawMenuItemGroup);