/// <reference types="react" />
import React from 'react';
import { TButtonIconProps } from '../ButtonIcon/ButtonIcon';
import { TInputProps } from '../input/Input';
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/lib/object/object';
export declare const PASSWORD_INPUT: symbol;
export declare type TFullPasswordInputProps = TInputProps & {
    theme: {
        container?: string;
        Input?: TInputProps['theme'];
        RevealButton?: TButtonIconProps['theme'];
    };
    Button?: React.ComponentClass<TButtonIconProps>;
    Input?: React.ComponentClass<TInputProps>;
    isDisabled?: boolean;
    IconShow: React.ComponentClass<any> | React.StatelessComponent<any>;
    IconHide: React.ComponentClass<any> | React.StatelessComponent<any>;
    isRevealed: boolean;
    onReveal: (isRevealed: boolean) => void;
};
export declare class RawPasswordInput extends React.Component<TFullPasswordInputProps> {
    render(): JSX.Element;
    onClickRevealButton: () => void;
}
export declare type TPasswordInputProps = ObjectClean<PartialKeys<TFullPasswordInputProps, 'theme'>>;
export declare const PasswordInput: React.ComponentClass<TPasswordInputProps>;
