'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Selectbox = exports.SELECTBOX = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _SelectboxAnchor = require('./SelectboxAnchor');

var _Popover = require('../Popover/Popover');

var _Menu = require('../Menu/Menu');

var _pure = require('../../utils/pure');

var _classnames4 = require('classnames');

var _classnames5 = _interopRequireDefault(_classnames4);

var _withTheme = require('../../utils/withTheme');

var _ResizeDetector = require('../ResizeDetector/ResizeDetector');

var _reactDom = require('react-dom');

var _raf = require('@devexperts/utils/lib/function/raf');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SELECTBOX = exports.SELECTBOX = Symbol('Selectbox');
var RawSelectbox = function (_React$Component) {
    _inherits(RawSelectbox, _React$Component);

    function RawSelectbox() {
        _classCallCheck(this, RawSelectbox);

        var _this = _possibleConstructorReturn(this, (RawSelectbox.__proto__ || Object.getPrototypeOf(RawSelectbox)).apply(this, arguments));

        _this.state = {
            isOpened: false
        };
        _this.wrapItem = function (child) {
            var _this$props = _this.props,
                theme = _this$props.theme,
                selectedIcon = _this$props.selectedIcon;
            var value = child.props.value;

            var isActive = typeof value !== 'undefined' && value === _this.props.value;
            var props = Object.assign({}, child.props, {
                isActive: isActive,
                text: child.props.children,
                children: React.createElement("div", { className: theme.container__item }, React.createElement("div", { className: theme.container__item__text }, child.props.children), isActive && React.createElement("span", { className: theme.container__item__activeIcon }, selectedIcon))
            });
            return React.cloneElement(child, props);
        };
        _this.onAnchorClick = function () {
            _this.setState({
                isOpened: !_this.state.isOpened
            });
        };
        _this.onItemSelect = function (value) {
            _this.setState({
                isOpened: false
            });
            _this.props.onValueChange && _this.props.onValueChange(value);
        };
        _this.onPopoverRequestClose = function () {
            _this.setState({
                isOpened: false
            });
        };
        _this.handleAnchorResize = (0, _raf.raf)(function (element) {
            var _element$getBoundingC = element.getBoundingClientRect(),
                width = _element$getBoundingC.width;

            if (_this.state.width !== width) {
                _this.setState({
                    width: width
                });
            }
        });
        return _this;
    }

    _createClass(RawSelectbox, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            // if (this.anchor && this.props.shouldSyncWidth) {
            // 	const element = findDOMNode(this.anchor);
            // 	NativeResizeDetector.listenTo(element, this.handleAnchorResize);
            // }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(newProps) {
            //todo: rebind
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.anchor) {
                var element = (0, _reactDom.findDOMNode)(this.anchor);
                _ResizeDetector.NativeResizeDetector.uninstall(element);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                Anchor = _props.Anchor,
                Popover = _props.Popover,
                Menu = _props.Menu,
                placeholder = _props.placeholder,
                children = _props.children,
                caretIcon = _props.caretIcon,
                theme = _props.theme,
                value = _props.value,
                selectedIcon = _props.selectedIcon,
                isDisabled = _props.isDisabled,
                isLoading = _props.isLoading;

            var menuTheme = {
                container: (0, _classnames5.default)(theme.container__menu, _defineProperty({}, theme.container__menu_hasSelectedItem, typeof selectedIcon !== 'undefined' && typeof this.props.value !== 'undefined'))
            };
            var anchorTheme = {
                container: theme.container__anchor,
                container_isOpened: theme.container_isOpened,
                text: theme.container__anchor__text,
                content: (0, _classnames5.default)(theme.container__anchor__content, _defineProperty({}, theme.container__anchor__content_hasCaret, !!caretIcon))
            };
            if (caretIcon) {
                anchorTheme.caret = (0, _classnames5.default)(theme.container__anchor__caret, _defineProperty({}, theme.container__anchor__caret_isReversed, this.state.isOpened));
                anchorTheme.wrapperCaret = theme.container__anchor__wrapperCaret;
            }
            var popoverTheme = {
                container: (0, _classnames5.default)(theme.container__popover),
                content: theme.container__popover__content
            };
            var valueText = placeholder;
            if (typeof value !== 'undefined') {
                var valueChild = React.Children.toArray(children).find(function (child) {
                    return child.props.value === value;
                });
                //existance is checked in prop types
                if (valueChild) {
                    valueText = valueChild.props.text || valueChild.props.children;
                }
            }
            var popoverStyle = void 0;
            if (typeof this.state.width !== 'undefined' && this.props.shouldSyncWidth) {
                popoverStyle = {
                    width: this.state.width
                };
            }
            return React.createElement(Anchor, { ref: function ref(el) {
                    return _this2.anchor = el;
                }, isDisabled: isDisabled, isLoading: isLoading, theme: anchorTheme, caretIcon: caretIcon, isOpened: this.state.isOpened, value: value, valueText: valueText, onClick: this.onAnchorClick }, React.createElement(Popover, { isOpened: this.state.isOpened, style: popoverStyle, theme: popoverTheme, closeOnClickAway: true, onRequestClose: this.onPopoverRequestClose, anchor: this.anchor }, React.createElement(Menu, { onItemSelect: this.onItemSelect, theme: menuTheme }, React.Children.map(children, this.wrapItem))));
        }
    }, {
        key: 'anchor',
        get: function get() {
            return this._anchor;
        },
        set: function set(value) {
            if (this._anchor !== value) {
                //uninstall previous
                if (this.anchor && this.props.shouldSyncWidth) {
                    var element = (0, _reactDom.findDOMNode)(this.anchor);
                    _ResizeDetector.NativeResizeDetector.uninstall(element);
                }
                //install new
                this._anchor = value;
                if (this.anchor && this.props.shouldSyncWidth) {
                    var _element = (0, _reactDom.findDOMNode)(this.anchor);
                    _ResizeDetector.NativeResizeDetector.listenTo(_element, this.handleAnchorResize);
                }
            }
        }
    }]);

    return RawSelectbox;
}(React.Component);
RawSelectbox.propTypes = {
    value: function value(props) {
        var type = _typeof(props.value);
        if (type !== 'undefined') {
            if (type !== 'string' && type !== 'number') {
                throw new Error('Value should be a string or a number');
            } else {
                if (!React.Children.toArray(props.children).find(function (child) {
                    return child.props.value === props.value;
                })) {
                    throw new Error('Value should be in passed children');
                }
            }
        }
    }
};
RawSelectbox.defaultProps = {
    Anchor: _SelectboxAnchor.SelectboxAnchor,
    Menu: _Menu.Menu,
    Popover: _Popover.Popover
};
RawSelectbox = tslib_1.__decorate([_pure.PURE], RawSelectbox);
var Selectbox = exports.Selectbox = (0, _withTheme.withTheme)(SELECTBOX)(RawSelectbox);