'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Input = exports.INPUT = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactDom = require('react-dom');

var ReactDOM = _interopRequireWildcard(_reactDom);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _pure = require('../../utils/pure');

var _withTheme = require('../../utils/withTheme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var INPUT = exports.INPUT = Symbol('Input');
var RawInput = function (_React$Component) {
    _inherits(RawInput, _React$Component);

    function RawInput() {
        _classCallCheck(this, RawInput);

        var _this = _possibleConstructorReturn(this, (RawInput.__proto__ || Object.getPrototypeOf(RawInput)).apply(this, arguments));

        _this.state = {
            isFocused: false
        };
        _this.onFocus = function (e) {
            if (!_this.props.isDisabled && !_this.state.isFocused && !_this.isFocusingOnInput && _this.input) {
                var input = ReactDOM.findDOMNode(_this.input);
                if (input) {
                    _this.isFocusingOnInput = true;
                    input.focus();
                    _this.isFocusingOnInput = false;
                }
                _this.setState({
                    isFocused: true
                });
                _this.props.onFocus && _this.props.onFocus(e);
            }
        };
        _this.onBlur = function (e) {
            if (!_this.props.isDisabled && _this.state.isFocused && !_this.isFocusingOnInput) {
                _this.setState({
                    isFocused: false
                });
                _this.props.onBlur && _this.props.onBlur(e);
            }
        };
        _this.onChange = function (e) {
            _this.props.onValueChange && _this.props.onValueChange(e.target.value);
            _this.props.onChange && _this.props.onChange(e);
        };
        return _this;
    }

    _createClass(RawInput, [{
        key: 'render',
        value: function render() {
            var _classnames,
                _this2 = this;

            var _props = this.props,
                theme = _props.theme,
                isDisabled = _props.isDisabled,
                isReadOnly = _props.isReadOnly,
                tabIndex = _props.tabIndex,
                children = _props.children,
                value = _props.value,
                error = _props.error,
                onClick = _props.onClick,
                onMouseDown = _props.onMouseDown,
                onMouseUp = _props.onMouseUp,
                onKeyDown = _props.onKeyDown,
                onKeyUp = _props.onKeyUp,
                onKeyPress = _props.onKeyPress,
                min = _props.min,
                placeholder = _props.placeholder,
                max = _props.max,
                type = _props.type,
                name = _props.name,
                pattern = _props.pattern,
                id = _props.id,
                onWheel = _props.onWheel;
            var isFocused = this.state.isFocused;

            var className = (0, _classnames3.default)(theme.container, (_classnames = {}, _defineProperty(_classnames, theme.container_isFocused, !isDisabled && isFocused), _defineProperty(_classnames, theme.container_isDisabled, isDisabled), _defineProperty(_classnames, theme.container_isReadOnly, isReadOnly), _defineProperty(_classnames, theme.container_hasError, Boolean(error)), _classnames));
            var isCustom = type === 'hidden';
            var keyboardEvents = {
                onKeyDown: onKeyDown,
                onKeyUp: onKeyUp,
                onKeyPress: onKeyPress
            };
            return React.createElement("div", Object.assign({ className: className, id: id, onClick: onClick, onMouseDown: onMouseDown, onMouseUp: onMouseUp, onFocus: this.onFocus, onBlur: this.onBlur, onWheel: onWheel, tabIndex: !isCustom && (isFocused || isDisabled) ? -1 : tabIndex }, isCustom && keyboardEvents), React.createElement("input", Object.assign({ className: theme.input, ref: function ref(el) {
                    return _this2.input = el;
                }, value: value, type: type, min: min, max: max, pattern: pattern, name: name, onChange: this.onChange, placeholder: placeholder, tabIndex: -1, readOnly: isReadOnly, disabled: isDisabled }, !isCustom && keyboardEvents)), children);
        }
    }]);

    return RawInput;
}(React.Component);
RawInput.defaultProps = {
    tabIndex: 0
};
RawInput = tslib_1.__decorate([_pure.PURE], RawInput);
var Input = exports.Input = (0, _withTheme.withTheme)(INPUT)(RawInput);